%global pkg hns3
%global kernel 5.10.134-19.an8
%define pkg_version 1.0
%define anolis_release 2

Name:           kmod-%{pkg}
Version:        %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:        %{pkg_version}~%{anolis_release}%{?dist}
Summary:        Hisilicon Ethernet driver
License:        GPLv2
Group:          System Environment/Kernel
Source:         kmod-%{pkg}-%{pkg_version}.tar.gz

BuildRequires: kernel = %{kernel}
BuildRequires: kernel-devel = %{kernel}
BuildRequires: kernel-headers = %{kernel}


Requires: kernel >= %{kernel}
Requires: kernel-headers >= %{kernel}

ExclusiveArch: aarch64
%define debug_package %{nil}

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
This package contains the hisilicon ethernet driver.

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
make -C src KSRC=/usr/src/kernels/%{kernel}.%{_arch}/ -j32

%install

rm -rf %{buildroot}
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/hns3/
find src -name *.ko | while read line
do
        cp $line %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/hns3/
done

# install的该段需要保留，weak-module相关
# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hnae3.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclgevf.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclge.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hns3.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi
%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hns3.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hnae3.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclgevf.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclge.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi

# files ########################################################################
%files
/lib/modules/%{kernel}.%{_arch}/extra/hns3/hns3.ko
/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclge.ko
/lib/modules/%{kernel}.%{_arch}/extra/hns3/hclgevf.ko
/lib/modules/%{kernel}.%{_arch}/extra/hns3/hnae3.ko

%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

# changelog  ###################################################################


%changelog
